unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ScktComp;

type
  TfmMain = class(TForm)
    bClient: TClientSocket;
    bServer: TServerSocket;
    RichEdit: TRichEdit;
    RadioGroup: TRadioGroup;
    edAddress: TEdit;
    Label1: TLabel;
    btnGO: TButton;
    Label2: TLabel;
    edNick: TEdit;
    Bevel1: TBevel;
    Label3: TLabel;
    btnSend: TButton;
    edTxt: TEdit;
    btnSys: TButton;
    procedure btnGOClick(Sender: TObject);
    procedure bClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure bClientConnecting(Sender: TObject; Socket: TCustomWinSocket);
    procedure bClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure bClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure bServerAccept(Sender: TObject; Socket: TCustomWinSocket);
    procedure bServerClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure bServerClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure btnSendClick(Sender: TObject);
    procedure bServerClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure bClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure bServerClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure btnSysClick(Sender: TObject);
  private
  public
  end;

  {    ,   
    ,   : ID  Word (2 ).
   ,        .
   ( )  }
  TMes = packed record {  224 }
    ID: Word; {ID = 0}
    Nick: String[20]; {  ,   !!!   !!}
    Txt: String[200];
  end;
  TSys = packed record {  103 }
    ID: Word; {ID = 1}
    Body: String[100];
  end;

const
  MaxSize = 224; {    }

var
  fmMain: TfmMain;

implementation

{$R *.dfm}

procedure PctToBuf(var Packet; var buf; Size: Word);
{   }
var
  arPacket: array[1..MaxSize] of byte absolute Packet;
  arBuf: array[1..MaxSize] of byte absolute buf;
  i: Word;
begin
  for i:=1 to Size do
    arBuf[i]:=arPacket[i];
end;

procedure BufToPct(var Packet; var buf; Size: Word);
{    }
var
  arPacket: array[1..MaxSize] of byte absolute Packet;
  arBuf: array[1..MaxSize] of byte absolute buf;
  i: Word;
begin
  for i:=1 to Size do
    arPacket[i]:=arBuf[i];
end;

procedure TfmMain.btnGOClick(Sender: TObject);
begin
{ ,  }
  if RadioGroup.ItemIndex=0 then
    if bClient.Active then
      bClient.Active:=False { }
    else begin
      bClient.Address:=edAddress.Text;
      bClient.Active:=True; { }
      Application.ProcessMessages;
    end
  else
    if bServer.Active then begin
      bServer.Active:=False; { }
      RichEdit.SelAttributes.Color:=clBlack;
      RichEdit.Lines.Add('>> Server closed');
    end
    else begin
      bServer.Active:=True; { }
      RichEdit.SelAttributes.Color:=clBlack;
      RichEdit.Lines.Add('>> Server started');
    end;

  {   ,  }
  if bClient.Active or bServer.Active then begin
    btnGo.Caption:='STOP';
    btnSend.Enabled:=True;
    btnSys.Enabled:=True;
    edAddress.ReadOnly:=True;
    RadioGroup.Enabled:=False;
  end
  else begin
    btnGo.Caption:='GO!';
    btnSend.Enabled:=False;
    btnSys.Enabled:=False;
    edAddress.ReadOnly:=False;
    RadioGroup.Enabled:=True;
  end;
end;

procedure TfmMain.bClientError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
{--,  ! -  ... :)
        ,
       ,    
       ,
    ,    .
   - ,  ... ,  update}
 RichEdit.SelAttributes.Color:=clRed;
 RichEdit.Lines.Add('>> ErrorCode: '+IntToStr(ErrorCode));
 ErrorCode:=0; { Windows-  }
 btnGo.Caption:='GO!';
 edAddress.ReadOnly:=False;
 RadioGroup.Enabled:=True;
 btnSend.Enabled:=False;
 btnSys.Enabled:=False;
end;

procedure TfmMain.bClientConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  {    ,       }
  RichEdit.SelAttributes.Color:=clBlack;
  RichEdit.Lines.Add('>> Connecting to '+Socket.RemoteAddress+'...');
end;

procedure TfmMain.bClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  {   .  !!!!}
  btnGo.Caption:='STOP';
  btnSend.Enabled:=True;
  btnSys.Enabled:=True;
  edAddress.ReadOnly:=True;
  RadioGroup.Enabled:=False;
  RichEdit.SelAttributes.Color:=clBlack;
  RichEdit.Lines.Add('>> Connected to '+Socket.RemoteAddress);
end;

procedure TfmMain.bClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  {   ,     .    Socket
    -   }
  btnGo.Caption:='GO!';
  edAddress.ReadOnly:=False;
  RadioGroup.Enabled:=True;
  btnSend.Enabled:=False;
  btnSys.Enabled:=False;
  RichEdit.SelAttributes.Color:=clRed;
  RichEdit.Lines.Add('>> Disconnected from '+Socket.RemoteAddress);
end;

procedure TfmMain.bServerAccept(Sender: TObject; Socket: TCustomWinSocket);
var
  ans: Word;
begin
  {     ,  ,     ... :)
   ,    Socket}
  Ans:=MessageBoxEx(Application.Handle,
                     PChar('   '+Socket.RemoteAddress+'. ?'),
                     PChar(''),
                     MB_YESNO or MB_ICONQUESTION,
                     LANG_RUSSIAN);
  if Ans=IDNO then
    Socket.Close; { ..}
end;

procedure TfmMain.bServerClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  {  !!!!}
  RichEdit.SelAttributes.Color:=clBlack;
  RichEdit.Lines.Add('>> '+Socket.RemoteAddress+' connected to server');
end;

procedure TfmMain.bServerClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  { }
  RichEdit.SelAttributes.Color:=clBlack;
  RichEdit.Lines.Add('>> '+Socket.RemoteAddress+' disconnected from server');
end;

procedure TfmMain.bServerClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  {      ,   .  .}
  RichEdit.SelAttributes.Color:=clRed;
  RichEdit.Lines.Add('>> '+Socket.RemoteAddress+' has ErrorCode: '+IntToStr(ErrorCode));
  Socket.Close;
  ErrorCode:=0;
end;

procedure TfmMain.btnSendClick(Sender: TObject);
var
  Mes: TMes;
  buf: array[1..SizeOf(TMes)] of byte;
  i: Word;
begin
  {  }
  Mes.ID:=0;
  if bClient.Active then begin
    Mes.Nick:=edNick.Text;
    Mes.Txt:=edTxt.Text;
    PctToBuf(Mes,buf,SizeOf(TMes)); { ,    !
                                       ,  }
    bClient.Socket.SendBuf(buf,SizeOf(TMes));
   {bClient.Socket.SendBuf(mes,SizeOf(TMes));     !}
  end
  else
  if bServer.Socket.ActiveConnections>0 then begin
    Mes.Nick:=edNick.Text;
    Mes.Txt:=edTxt.Text;
    PctToBuf(Mes,buf,SizeOf(TMes));
    for i:=0 to bServer.Socket.ActiveConnections-1 do
      bServer.Socket.Connections[i].SendBuf(buf,SizeOf(TMes));
    RichEdit.SelAttributes.Color:=clBlue;
    RichEdit.Lines.Add(Mes.Nick+': '+Mes.Txt);
  end;
end;

procedure TfmMain.btnSysClick(Sender: TObject);
var
  Sys: TSys;
  str: String;
  i: Word;
begin
  {  }
  Sys.ID:=1;
  Str:='Fuck admin!'; {, }
  InputQuery('','',Str);
  Sys.Body:=Str;
  if bClient.Active then
    bClient.Socket.SendBuf(sys,SizeOf(TSys))
  else
  if bServer.Socket.ActiveConnections>0 then begin
    for i:=0 to bServer.Socket.ActiveConnections-1 do
      bServer.Socket.Connections[i].SendBuf(sys,SizeOf(TSys));
    RichEdit.SelAttributes.Color:=clRed;
    RichEdit.Lines.Add('>> '+Sys.Body);
  end;
end;

procedure TfmMain.bServerClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  buf: array[1..MaxSize] of byte;
  Size: Word;
  ID: Word;
  i: Word;
  Sys: ^TSys;
  Mes: ^TMes;
begin
  Size:=Socket.ReceiveLength; { - }
  Socket.ReceiveBuf(buf,Size); {   -  .
                                   Size  }
  BufToPct(ID,buf,2);
  case ID of
    0: begin
         New(Mes);
         BufToPct(Mes^,buf,Size);
         RichEdit.SelAttributes.Color:=clBlue;
         RichEdit.Lines.Add(Mes^.Nick+': '+Mes^.Txt);
         {   }
         for i:=0 to bServer.Socket.ActiveConnections-1 do
           bServer.Socket.Connections[i].SendBuf(Mes^,Size);
         Dispose(Mes);
       end;
    1: begin
         New(Sys);
         BufToPct(Sys^,buf,Size);
         RichEdit.SelAttributes.Color:=clRed;
         RichEdit.Lines.Add('>> '+Sys^.Body);
         {   }
         for i:=0 to bServer.Socket.ActiveConnections-1 do
           bServer.Socket.Connections[i].SendBuf(Sys^,Size);
         Dispose(Sys);
       end;
  end;

end;

procedure TfmMain.bClientRead(Sender: TObject; Socket: TCustomWinSocket);
var
  buf: array[1..MaxSize] of byte;
  Size, ID: Word;
  Sys: ^TSys;
  Mes: ^TMes;
begin
  {  !}
  Size:=Socket.ReceiveLength; { - }
  Socket.ReceiveBuf(buf,Size);
  BufToPct(ID,buf,2);
  case ID of
    0: begin
         New(Mes);
         BufToPct(Mes^,buf,Size);
         RichEdit.SelAttributes.Color:=clBlue;
         RichEdit.Lines.Add(Mes^.Nick+': '+Mes^.Txt);
         Dispose(Mes);
       end;
    1: begin
         New(Sys);
         BufToPct(Sys^,buf,Size);
         RichEdit.SelAttributes.Color:=clRed;
         RichEdit.Lines.Add('>> '+Sys^.Body);
         Dispose(Sys);
       end;
  end;
end;

end.
